web/apps/materiel/urls.py
from django.urls import path

from .views import EmpruntLocalFeed, emprunt, emprunt_disponibilite, \
    emprunt_local, local_disponibilite, \
    local_gestion, local_statut, local_disponible, emprunt_gestion, \
    emprunt_statut, search_materiel, ajout_emprunt_element, gestion_materiel, \
    suppr_materiel, ajout_type_materiel_modal, modifier_materiel_modal, \
    modifier_materiel, ajout_type_materiel, get_photo_materiel, \
    materiel_description, supprimer_emprunt_materiel, supprimer_emprunt_local, \
    mes_emprunts_materiel, mes_emprunts_local

urlpatterns = [
    path('emprunt/', emprunt, name='emprunt'),
    path('emprunt/tache-<int:id_tache>', emprunt, name='emprunt'),
    path('emprunt/disponibilite/', emprunt_disponibilite,
         name='emprunt_disponibilite'),

    path('mes_emprunts/materiel/', mes_emprunts_materiel, name='mes_emprunts_materiel'),
    path('mes_emprunts/local/', mes_emprunts_local, name='mes_emprunts_local'),
    path('mes_emprunts/materiel/<int:pk>/supprimer', supprimer_emprunt_materiel,
         name='supprimer_emprunt_materiel'),
    path('mes_emprunts/local/<int:pk>/supprimer', supprimer_emprunt_local,
             name='supprimer_emprunt_local'),

    path('local/', emprunt_local, name='emprunt_local'),
    path('local/disponibilite/', local_disponibilite,
         name='local_disponibilite'),

    path('local/gestion/', local_gestion, name='local_gestion'),
    path('local/statut/', local_statut, name='local_statut'),
    path('api/local/calendrier/', EmpruntLocalFeed(), name='local_calendrier'),
    path('api/local/disponibilite', local_disponible),

    path('emprunt/gestion/', emprunt_gestion, name='emprunt_gestion'),
    path('emprunt/statut/', emprunt_statut, name='emprunt_statut'),
    path('materiel/search/', search_materiel, name='search_materiel'),
    path('emprunt/ajout/', ajout_emprunt_element,
         name='ajout_emprunt_element'),

    path('materiel/', gestion_materiel, name='materiel'),
    path('supprimer/', suppr_materiel, name="suppr_materiel"),
    path('ajout/type/modal', ajout_type_materiel_modal,
         name='ajout_type_materiel_modal'),
    path('modifier/modal', modifier_materiel_modal,
         name='modifier_materiel_modal'),
    path('modifier/', modifier_materiel, name='modifier_materiel'),
    path('ajout/type/', ajout_type_materiel, name='ajout_type_materiel'),
    path('photo/<int:materiel_id>', get_photo_materiel, name="photo_materiel"),

    path('description/', materiel_description,
         name='materiel_description'),
]

web/intramwet/urls.py
from django.conf import settings
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('intramwet.core.urls')),
    path('admin/', admin.site.urls),
    path('django-rq/', include('django_rq.urls'))
]

# Sentry testing
if settings.DEBUG:
    def trigger_error(request):
        division_by_zero = 1 / 0

    urlpatterns += path('sentry-debug/', trigger_error),

web/apps/materiel/models.py
from datetime import datetime, timezone

from django.contrib.auth import get_user_model
from django.contrib.auth.models import Permission
from django.contrib.contenttypes.models import ContentType
from django.db import models
from django.db.models.signals import post_save, pre_delete
from django.dispatch import receiver
from django.templatetags.static import static
from django.utils.functional import cached_property


class TypeMateriel(models.Model):
    typeMateriel = models.CharField(max_length=50, unique=True)
    consommable = models.BooleanField("consommable", default=False)

    def __str__(self):
        return self.typeMateriel


class ProprietaireManager(models.Manager):
    def emprunt_gratuit(self, utilisateur):
        return [p for p in self.all() if
                utilisateur.has_perm(p.emprunt_gratuit_full_permission_name)]

    def emprunt_payant(self, utilisateur):
        return [p for p in self.all() if
                utilisateur.has_perm(p.emprunt_payant_full_permission_name)]


class ProprietaireMateriel(models.Model):
    """
    Attention, si vous modifiez la structure des permissions, il faut absolument modifer le fichier
    materiel/migrations/init_db_2.py qui initialise les permissions et les attribue aux différents groupes
    """
    nomProprietaire = models.CharField("nom du propriétaire", max_length=50,
                                       unique=True)
    objects = ProprietaireManager()

    @property
    def emprunt_gratuit_permission_name(self):
        return "emprunt_gratiut_proprietaire_" + str(self.id)

    @property
    def emprunt_payant_permission_name(self):
        return "emprunt_payant_proprietaire_" + str(self.id)

    @cached_property
    def emprunt_gratuit_full_permission_name(self):
        return "materiel." + self.emprunt_gratuit_permission_name

    @cached_property
    def emprunt_payant_full_permission_name(self):
        return "materiel." + self.emprunt_payant_permission_name

    def create_emprunt_gratuit_permission(self):
        content_type = ContentType.objects.get_for_model(ProprietaireMateriel)
        Permission.objects.create(
            codename=self.emprunt_gratuit_permission_name,
            name='Peut emprunter gratuitement le matériel de la catégorie ' + str(
                self.id),
            content_type=content_type,
        )

    def create_emprunt_payant_permission(self):
        content_type = ContentType.objects.get_for_model(ProprietaireMateriel)
        Permission.objects.create(
            codename=self.emprunt_payant_permission_name,
            name='Peut louer le matériel de la catégorie ' + str(self.id),
            content_type=content_type,
        )

    def get_emprunt_gratuit_permission(self):
        content_type = ContentType.objects.get_for_model(ProprietaireMateriel)
        return Permission.objects.get(
            codename=self.emprunt_gratuit_permission_name,
            content_type=content_type,
        )

    def get_emprunt_payant_permission(self):
        content_type = ContentType.objects.get_for_model(ProprietaireMateriel)
        return Permission.objects.get(
            codename=self.emprunt_payant_permission_name,
            content_type=content_type,
        )

    def delete_emprunt_gratuit_permission(self):
        self.get_emprunt_gratuit_permission().delete()

    def delete_emprunt_payant_permission(self):
        self.get_emprunt_payant_permission().delete()

    def __str__(self):
        return self.nomProprietaire


@receiver(post_save, sender=ProprietaireMateriel)
def init_permissions_on_prorietaire_created(sender,
                                            instance: ProprietaireMateriel,
                                            created: bool, **kwargs):
    if created:
        instance.create_emprunt_gratuit_permission()
        instance.create_emprunt_payant_permission()


@receiver(pre_delete, sender=ProprietaireMateriel)
def delete_permissions_on_proprietaire_deleted(sender,
                                               instance: ProprietaireMateriel,
                                               **kwargs):
    instance.delete_emprunt_gratuit_permission()
    instance.delete_emprunt_payant_permission()


class MaterielEmpruntable:
    def __init__(self, materiel, emprunt_gratuit: bool):
        self.materiel = materiel
        self.emprunt_gratuit = emprunt_gratuit


class MaterielManager(models.Manager):
    def emprunt_gratuit(self, utilisateur):
        return self.filter(
            proprietaireMatos__in=ProprietaireMateriel.objects.emprunt_gratuit(
                utilisateur))

    def emprunt_payant(self, utilisateur):
        return self.filter(
            proprietaireMatos__in=ProprietaireMateriel.objects.emprunt_payant(
                utilisateur)).exclude(
            proprietaireMatos__in=ProprietaireMateriel.objects.emprunt_gratuit(
                utilisateur))

    def empruntable(self, utilisateur):
        return self.emprunt_gratuit(utilisateur) | self.emprunt_payant(
            utilisateur)

    def empruntable_categorise(self, utilisateur):
        materiel_gratuit = self.emprunt_gratuit(utilisateur)
        materiel_payant = self.emprunt_payant(utilisateur)
        materiel = {}
        for m in materiel_gratuit:
            if m.typeMateriel.typeMateriel not in materiel:
                materiel[m.typeMateriel.typeMateriel] = []
            materiel[m.typeMateriel.typeMateriel].append(
                MaterielEmpruntable(m, True))
        for m in materiel_payant:
            if m.typeMateriel.typeMateriel not in materiel:
                materiel[m.typeMateriel.typeMateriel] = []
            materiel[m.typeMateriel.typeMateriel].append(
                MaterielEmpruntable(m, False))
        return materiel

    def disponible(self, utilisateur: get_user_model(), date_debut: datetime,
                   date_fin: datetime) -> dict:
        """
        Permet de connaître le matos disponible, ainsi que sa quantité restante,
        en fonction de ce à quoi l'utilisateur peut accéder.

        :param utilisateur: l'utilisateur qui veut emprunter le matériel
        :param date_debut: date de début de l'emprunt
        :param date_fin: date de fin de l'emprunt
        :return: la liste du matériel empruntable au format JSON :
        {
            idMateriel1 : {'dispo' : True, 'quantite' : 2}
            idMateriel2 : {'dispo' : False}
            ...
        }
        """
        matos_emruntable = self.empruntable(utilisateur=utilisateur)
        matos_disponible = {}
        for m in matos_emruntable:
            quantite_restante = m.quantite_restante(date_debut=date_debut,
                                                    date_fin=date_fin)
            matos_disponible[m.id] = {
                'dispo': quantite_restante > 0,
                'quantite': quantite_restante
            }
        return matos_disponible


class Materiel(models.Model):
    nom = models.CharField(max_length=100)
    typeMateriel = models.ForeignKey(TypeMateriel, on_delete=models.CASCADE)
    proprietaireMatos = models.ForeignKey(ProprietaireMateriel,
                                          on_delete=models.CASCADE)
    anneeAchat = models.DateField(null=True)
    montantCaution = models.FloatField(null=True)
    prixLocation = models.FloatField("Prix de location du matériel", default=0)
    prixAchat = models.FloatField("Prix d'achat du matériel", default=0)
    photo = models.ImageField(upload_to='photos_matos/%Y/', null=True)
    description = models.TextField(null=True)
    lienDocumentation = models.CharField("lien vers la doc", max_length=500, null=True, default="")
    reference = models.CharField(max_length=500, null=True, default="")
    quantite = models.IntegerField(default=1)
    objects = MaterielManager()

    def __str__(self):
        return "%s | %s | %d" % (self.typeMateriel, self.nom, self.quantite)

    def quantite_restante(self, date_debut: datetime, date_fin: datetime,
                          strict: bool = True) -> int:
        elements = EmpruntElement.objects.intersecting(id_materiel=self.id,
                                                       date_debut=date_debut,
                                                       date_fin=date_fin,
                                                       strict=strict)
        return self.quantite - sum(e.quantite for e in elements)

    @cached_property
    def photo_url(self):
        return self.photo.url if self.photo else static('images/pas_de_photo.png')


class EmpruntManager(models.Manager):
    def intersecting(self, date_debut: datetime, date_fin: datetime):
        return self.filter(debut__lt=date_fin, fin__gt=date_debut)


class Emprunt(models.Model):
    membre = models.ForeignKey(get_user_model(), on_delete=models.PROTECT,
                               related_name='membre')
    debut = models.DateTimeField()
    fin = models.DateTimeField()
    description = models.TextField(null=True)
    commentaire = models.TextField(null=True, blank=True)
    dateCommentaire = models.DateTimeField(null=True, blank=True)
    auteurCommentaire = models.ForeignKey(get_user_model(), null=True, blank=True,
                                          on_delete=models.PROTECT,
                                          related_name='auteurCommentaire')
    objects = EmpruntManager()

    def __str__(self):
        return "%s | %s | %s" % (self.membre, self.debut, self.fin)

    @cached_property
    def nb_jours_emprunt(self):
        return max(1, (self.fin.date() - self.debut.date()).days)


class EmpruntMateriel(Emprunt):
    def est_en_attente(self):
        if self.elements.all().filter(statut=EmpruntElement.EN_ATTENTE):
            return True
        else:
            return False

    def est_a_venir(self):
        if not self.est_termine() and not self.est_en_attente():
            if self.fin > datetime.now(timezone.utc):
                return True
            else:

web/apps/materiel/views/api.py
from datetime import datetime

from django.http import JsonResponse
from django.urls import reverse
from django_ical.views import ICalFeed

from ..models import EmpruntLocal


class EmpruntLocalFeed(ICalFeed):
    product_id = '-//medialamouette.fr//Local//FR'
    timezone = 'UTC+2'
    file_name = 'local.ics'

    def items(self):
        return EmpruntLocal.objects.all().order_by('debut')

    def item_guid(self, item: EmpruntLocal):
        return f'emprunt_local_{item.id}'

    def item_title(self, item: EmpruntLocal):
        return f'Emprunt du local par {item.membre.nomComplet}'

    def item_description(self, item: EmpruntLocal):
        return item.description

    def item_start_datetime(self, item: EmpruntLocal):
        return item.debut

    def item_end_date_time(self, item: EmpruntLocal):
        return item.fin

    def item_link(self, item: EmpruntLocal):
        return reverse("emprunt_local")


def local_disponible(request) -> JsonResponse:
    date_format = "%d/%m/%Y %H:%M"
    date_debut = datetime.strptime(request.GET.get("date_debut"), date_format)
    date_fin = datetime.strptime(request.GET.get("date_fin"), date_format)
    return JsonResponse({
        'disponible': not EmpruntLocal.local_est_emprunte(
            date_debut=date_debut,
            date_fin=date_fin),
        'pas-en-attente': not EmpruntLocal.local_est_emprunte(
            date_debut=date_debut,
            date_fin=date_fin,
            strict=False)
    })

web/apps/materiel/views/gestion_local.py
from datetime import datetime

from django.http import JsonResponse
from django.shortcuts import render
from django.utils import timezone

from ..decorators import can_manage_local
from ..models import EmpruntLocal
from apps.conf.bot import Email


@can_manage_local
def local_gestion(request):
    emprunts_en_attente = EmpruntLocal.objects.filter(
        statut=EmpruntLocal.EN_ATTENTE).order_by('debut')
    emprunts_a_venir = EmpruntLocal.objects.filter(statut=EmpruntLocal.VALIDE,
                                                   fin__gte=datetime.now(
                                                       timezone.utc)).order_by(
        'debut')
    emprunts_termines = EmpruntLocal.objects.filter(
        fin__lt=datetime.now(timezone.utc)) \
        .union(EmpruntLocal.objects.filter(
        statut=EmpruntLocal.REFUSE)).distinct().order_by('-debut')
    valide = EmpruntLocal.VALIDE
    refuse = EmpruntLocal.REFUSE

    return render(request, 'local_gestion.html', locals())


@can_manage_local
def local_statut(request):
    if request.method == 'POST':
        valider = int(request.POST['valider'])
        emprunt = EmpruntLocal.objects.get(id=request.POST['id_emprunt'])
        commentaire = request.POST['commentaire']

        if valider:
            if not EmpruntLocal.local_est_emprunte(emprunt.debut, emprunt.fin):
                emprunt.statut = EmpruntLocal.VALIDE
                Email('emails/emprunt_local_valide.html', emprunt.membre.email,
                      {'emprunt': emprunt, 'valide': True}).send()
        else:
            emprunt.statut = EmpruntLocal.REFUSE
            Email('emails/emprunt_local_valide.html', emprunt.membre.email,
                  {'emprunt': emprunt, 'valide': False}).send()
        emprunt.commentaire = commentaire
        emprunt.auteurCommentaire = request.user
        emprunt.dateCommentaire = datetime.now(timezone.utc)

        emprunt.save()
    return JsonResponse({})

web/apps/materiel/templates/ajout_type_materiel_modal.html
<div class="modal-header">
    <h5 class="modal-title" id="ajoutElementModalLabel">Rajouter un élément</h5>
    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
        <span aria-hidden="true">&times;</span>
    </button>
</div>
<div class="modal-body">
    <div class="form-group">
        <label for="elemModal">Type de matériel à ajouter :</label>
        <input type="text" class="form-control" name="elemModal" placeholder="Nom du type"/>
    </div>
</div>
<div class="modal-footer">
    <button type="button" class="btn btn-secondary" data-dismiss="modal">Fermer</button>
    <button type="button" class="btn btn-primary" onclick="ajoutType()">Ajouter</button>
</div>

<script type="text/javascript">
    function ajoutType() {
        type = $('input[name="elemModal"]').val();
        $('.modal .btn-primary').addClass('disabled');
        $.ajax({
            url: "{% url 'ajout_type_materiel' %}",
            data: {
                'type': type,
                'csrfmiddlewaretoken': '{{ csrf_token }}',
            },
            dataType: 'json',
            type: 'POST',
            success: function (data) {
                if (data['success']) {
                    $('.modal-body').html("<p>Type de matériel ajouté !</p>");
                    setTimeout(() => {
                        location.reload();
                    }, 500);
                } else {
                    alert("Erreur : Merci de recommencer la procédure !");
                    location.reload();
                }

            }
        });
    }
</script>

web/apps/materiel/templates/emprunt_alertes.html
{% for alert in alerts %}
    <div class="alert alert-{{ alert.type }}" role="alert">
        <strong>{{ alert.titre }}</strong>{{ alert.contenu }}
    </div>
{% endfor %}

web/apps/materiel/templates/gestion_materiel.html
{% extends "materiel.html" %}
{% load static icon %}

{% block title %}Gestion du matériel{% endblock %}

{% block navbar_materiel_bureau %}
    active
{% endblock %}

{% block content %}

    <!-- Modal -->
    <div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="modalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <p>
                    Chargement ...
                </p>
            </div>
        </div>
    </div>

    <header>
        <h1>Gestion du matériel</h1>

        {% if alerts %}
            <div class="header-content">
                {% for alert in alerts %}
                    <div class="alert alert-{{ alert.type }}" role="alert">
                        <strong>{{ alert.titre }}</strong>{{ alert.contenu }}
                    </div>
                {% endfor %}
            </div>
        {% endif %}
    </header>


    <div class="container-fluid">
        <div class="collapsible-section-title" onclick="toggleForm()">
            <h2 class="title">Ajouter un élément</h2>
            <h2 class="title">
                <a id="collapseLinkForm" class="title collapse-link toggle-off" data-toggle="collapse" href="#addForm">&gt</a>
            </h2>
        </div>

        <section>
            <form id="addForm" class="needs-validation collapse" enctype="multipart/form-data" method="post" action="{% url 'materiel' %}">
                {% csrf_token %}

                <!-- Nom -->
                <div class="form-group">
                    {{ form.nom.label_tag }}
                    {{ form.nom }}
                    <div class="invalid-feedback">
                        Vous devez spécifier un nom valide !
                    </div>
                </div>

                <!-- Type -->
                <div class="form-group">
                    {{ form.typeMateriel.label_tag }}
                    <a data-toggle="modal" id="btn-ajoutType" data-target="#modal"
                       class="btn btn-outline-dark btn-sm"><i class="fas fa-plus-circle"></i> Ajouter un type</a>
                    {{ form.typeMateriel }}
                    <div class="invalid-feedback">
                        Vous devez spécifier un type de matériel !
                    </div>
                </div>


                <!-- Propriétaire -->
                <div class="form-group">
                    {{ form.proprietaireMatos.label_tag }}
                    {{ form.proprietaireMatos }}
                </div>

                <!-- AnnéeAchat -->
                <div class="form-group">
                    {{ form.anneeAchat.label_tag }}
                    <div class="input-group" id="{{ form.anneeAchat.id_for_label }}" data-target-input="nearest">
                        <div class="input-group-prepend" data-target="#{{ form.anneeAchat.id_for_label }}"
                             data-toggle="datetimepicker">
                            <span class="input-group-text"><i class="far fa-calendar"></i></span>
                        </div>
                        {{ form.anneeAchat }}
                        <div class="invalid-feedback">
                            Vous devez spécifier une date d'achat ! (ex: 26/12/2018)
                        </div>
                    </div>
                </div>

                <!-- Caution -->
                <div class="form-group">
                    {{ form.montantCaution.label_tag }}
                    <div class="input-group">
                        {{ form.montantCaution }}
                        <div class="input-group-append">
                            <span class="input-group-text">€</span>
                        </div>
                    </div>
                    <div class="invalid-feedback">
                        Vous devez spécifier un montant de caution ! (ex: 300€)
                    </div>
                </div>

                <div class="form-group">
                    {{ form.prixLocation.label_tag }}
                    <div class="input-group">
                        {{ form.prixLocation }}
                        <div class="input-group-append">
                            <span class="input-group-text">€</span>
                        </div>
                    </div>
                </div>

                <p>
                    {{ form.photo.label_tag }}
                    {{ form.photo }}
                </p>


                <!-- Quantité -->
                <div class="form-group">
                    {{ form.quantite.label_tag }}
                    {{ form.quantite }}
                    <div class="invalid-feedback">
                        Vous devez spécifier une quantité !
                    </div>
                </div>

                <!-- Description -->
                <div class="form-group">
                    {{ form.description.label_tag }}
                    {{ form.description }}
                    <div class="invalid-feedback">
                        Vous devez ajouter une description !
                    </div>
                </div>

                <!-- Bouton -->
                <div class="row">
                    <div class="offset-md-5 col-md-2">
                        <button type="submit" id="valider" class="btn btn-primary btn-xs">Ajouter l'élément</button>
                    </div>
                </div>
            </form>
        </section>

        <h2 class="title">Modifier la liste du matériel</h2>
        {% regroup materiels by typeMateriel as materiels_categorises %}
        {% for type in materiels_categorises %}
            {% if type.grouper %}
                <h3>{{ type.grouper.typeMateriel }}</h3>
            {% else %}
                <h3>Autres</h3>
            {% endif %}

            {% for matos in type.list %}
                <div class="card card-lg">
                    <div class="card-body">
                        <div class="row" id="row-{{ matos.id }}">
                            <div class="col-md-1">
                                <img class="photo-matos" src="{% url 'photo_materiel' matos.id %}" name="{{ matos.id }}"
                                     alt="Photo du {{ matos.nom }}"/>
                            </div>
                            <div class="col-md-8">
                                <h3><a data-toggle="collapse" class="dropdown-toggle" aria-expanded="false"
                                       href="#caracteristiques-{{ matos.id }}">{{ matos.nom }}</a></h3>
                                <p>{{ matos.description }}</p>
                                <div class="row">
                                    <ul class="list-group collapse" id="caracteristiques-{{ matos.id }}">
                                        <li class="list-group-item">Type : {{ matos.typeMateriel }}</li>
                                        <li class="list-group-item">Quantité : {{ matos.quantite }}</li>
                                        <li class="list-group-item">Propriétaire : {{ matos.proprietaireMatos }}</li>
                                        <li class="list-group-item">Date d'achat : {{ matos.anneeAchat }}</li>
                                        <li class="list-group-item">Caution : {{ matos.montantCaution }}€</li>
                                        <li class="list-group-item">Prix de location : {{ matos.prixLocation }}€</li>
                                    </ul>
                                </div>
                            </div>
                            <div class="col-md-1">
                                <button type="button" id="modifier-{{ matos.id }}" name="{{ matos.id }}"
                                        class="btn btn-outline-dark" data-toggle="modal" data-target="#modal">Modifier
                                </button>
                            </div>
                            <div class="col-md-1">
                                <button type="button" name="{{ matos.id }}" class="btn btn-danger suppr-btn"
                                        href="javascript:supprimer({{ matos.id }});"
                                        data-toggle="confirmation" data-btn-ok-label="Oui"
                                        data-btn-cancel-label="Non" data-btn-cancel-class="btn-danger"
                                        data-title="Supprimer ce matériel ?">Supprimer
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            {% empty %}
                <p>Il n'y a pas de materiel </p>
            {% endfor %}
            <hr>
        {% endfor %}

    </div>
{% endblock %}

{% block footer_javascript %}
    {# Plugin Date Time Picker #}
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/moment.min.js"></script>
    <script type="text/javascript"
            src="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/js/tempusdominus-bootstrap-4.min.js"></script>
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/css/tempusdominus-bootstrap-4.min.css"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/locale/fr.js"></script>

    {# Plugin confirmation box #}
    <script src="https://cdn.jsdelivr.net/npm/bootstrap-confirmation2@4.0.0/dist/bootstrap-confirmation.min.js"></script>


    <script type="text/javascript">
        $(function () {
            $('[data-toggle=confirmation]').confirmation({
                rootSelector: '[data-toggle=confirmation]'
            });

            $('#id_anneeAchat').datetimepicker({
                locale: 'fr',
                format: 'L'
            });

            $('#modal').on('show.bs.modal', function (event) {
                let button = $(event.relatedTarget);
                if (button.attr('id') === "btn-ajoutType") {
                    $.ajax({
                        url: '{% url 'ajout_type_materiel_modal' %}',
                        dataType: 'html',
                        data: {
                            'csrfmiddlewaretoken': '{{ csrf_token }}',
                        },
                        type: 'POST',
                        success: function (data) {
                            $('#modal .modal-content').html(data);
                        }
                    });
                } else if (/^modifier-[0-9]*$/.test(button.attr('id'))) {
                    let id = parseInt(button.attr('id').substring(9));
                    $.ajax({
                        url: '{% url 'modifier_materiel_modal' %}',
                        dataType: 'html',
                        data: {
                            'id': id,
                            'csrfmiddlewaretoken': '{{ csrf_token }}',
                        },
                        type: 'POST',
                        success: function (data) {
                            $('#modal .modal-content').html(data);
                        }
                    });
                }
            });

            $('#modal').on('hide.bs.modal', function (event) {
                $('#modal-content').html('<p>Chargement ...</p>')
            });
        });

        function supprimer(id) {
            $.ajax({
                url: '{% url 'suppr_materiel' %}',
                data: {
                    'id': id,
                    'csrfmiddlewaretoken': '{{ csrf_token }}',
                },
                dataType: 'json',
                type: 'POST',
                success: function (data) {
                    if (data['success']) {
                        $('#row-' + data['id']).hide();
                    } else {
                        alert("Erreur dans la suppression : Contactez les administrateurs du site !");
                    }
                },
                error: function () {
                    alert("Erreur : Merci de recommencer la procédure.");
                    location.reload();
                }
            });
        }

        function toggleForm() {
            $('#addForm').collapse('toggle');
            if ($('#collapseLinkForm').hasClass('toggle-on')) {
                $('#collapseLinkForm').removeClass('toggle-on');
                $('#collapseLinkForm').addClass('toggle-off');
            } else {
                $('#collapseLinkForm').removeClass('toggle-off');
                $('#collapseLinkForm').addClass('toggle-on')
            }
        }
    </script>
{% endblock %}

web/apps/materiel/templates/local.html
{% extends "base_navbar.html" %}
{% load static %}

{% block navbar_local %}
    active
{% endblock %}

{% block no_javascript_error %}
    {% include "no_javascript_error.html" %}
{% endblock %}

{% block head_css %}
    <link href="{% static 'materiel/css/materiel.css' %}"
          rel="stylesheet" media="screen">
{% endblock %}

web/apps/materiel/templates/materiel.html
{% extends "base_navbar.html" %}
{% load static %}

{% block navbar_materiel %}
    active
{% endblock %}

{% block no_javascript_error %}
    {% include "no_javascript_error.html" %}
{% endblock %}

{% block head_css %}
    <link href="{% static 'materiel/css/materiel.css' %}"
          rel="stylesheet" media="screen">
{% endblock %}